<h1 align="center">YusarinBot</h1>

<p align="center">
    <a href="https://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html">
        <img alt="License: GPL v2" src="https://img.shields.io/badge/License-GPL_v2-blue.svg">
    </a>
    <a href="https://crowdin.com/project/yusarinbot">
        <img alt="Crowdin" src="https://badges.crowdin.net/yusarinbot/localized.svg">
    </a>
    <a href="https://git.end-play.xyz/profitroll/YusarinBot">
        <img alt="Code style: black" src="https://img.shields.io/badge/code%20style-black-000000.svg">
    </a>
    <a href="https://discord.com/invite/2zpzErtnNT">
        <img alt="Discord" src="https://img.shields.io/discord/940760922346123284">
    </a>
</p>

Simple, easy to set up, yet reliable.  
A specially designed bot for creating private voice channels on your Discord servers.  
Installation instructions are listed below. Please, make sure you have installed dependencies before opening issue here.

> Since version 1.5 only slash commands are supported. If you'd like to use old-fashioned commands and commands prefix feature – consider installing [1.4 version](https://git.end-play.xyz/profitroll/YusarinBot/releases/tag/v1.4) which is the last one compatible with those.

## Installation (Short)

1. `git clone https://git.end-play.xyz/profitroll/YusarinBot`
2. `cd YusarinBot`
3. `pip install -r requirements.txt`
4. `nano config.json`
5. `python yusarin.py`

## Installation (Detailed)

1. Download and install Python 3.8+
2. Download bot's release: <https://git.end-play.xyz/profitroll/YusarinBot/releases/latest>
3. Unpack your archive to folder. Name it YusarinBot for example
4. Change working directory using `cd YusarinBot` or `cd FolderYouHaveCreated`
5. If you're using Linux system - install [dependencies for Pycord](https://docs.pycord.dev/en/stable/installing.html#installing)
6. Run `pip install -r requirements.txt` to install dependencies
7. [Optionally] run `pip install -r requirements-optional.txt` to install optional dependencies
8. Create new Discord application at <https://discord.com/developers/applications>
9. You can rename it however you want, set needed descriptions etc
10. Go to "Bot" tab and enable application as bot
11. Copy token of your bot
12. Open file `config.json` with your favorite text editor and paste your token as value of "bot_token" key
13. Copy your own Discord ID and paste it as value of "owner" key (How to get ID: <https://support.playhive.com/discord-user-id/>)
14. Bot is ready! Run it using `python yusarin.py`

## Config explanation

Default configuration file is [available here](https://git.profitroll.eu/profitroll/YusarinBot/src/branch/main/config.json)

- "debug" - Option that enables more detailed log messages [Boolean]
- "owner" - Discord ID of user who will be able to execute admin commands (`$shutdown` for example) [Integer]
- "bot_name" - Name of your bot. Is not used anywhere yet [String]
- "bot_token" - Token of your Discord bot [String]
- "bot_prefix" - Default prefix for all bot commands [String]
- "bot_locale" - Default language file of bot. Name of file in `locale` folder without extension is used [String]
- "bot_activity" - The name (string) of the song bot will be listening to [String]
- "color_default" - HTML color used in help messages embed [String]
- "color_ok" - HTML color used on command success embed [String]
- "color_warn" - HTML color used in all warning embeds [String]
- "color_error" - HTML color used on command error embed [String]
- "enable_nomic" - Option that allows you to create additional text channel for "nomic" purposes [Boolean]
- "bot_site" - http or https link that will be used in help message header [String]
- "bot_icon" - http or https link that will be used in help message header's icon [String]
- "check_for_updates" - Option that defines whether bot should check for a new version available [Boolean]
- "auto_clear_trash" - Option that defines whether bot should clean all buggy inactive channels every "auto_clear_timer" seconds [Boolean]
- "auto_clear_timer" - Option that defines how often "auto_clear_trash" will do its job [Integer]

## Extra

1. Bot doesn't have any self updaters **yet**
2. You can add public version of the bot to your Discord server using this link: <https://www.end-play.xyz/yusarin/invite>
3. If you have questions/suggestions - just join our [Discord Support Server](https://discord.com/invite/2zpzErtnNT)
